
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega164A
;Program type             : Application
;Clock frequency          : 20.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega164A
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1279
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x04FF
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _i=R3
	.DEF _flag_stare=R5
	.DEF _sum=R7
	.DEF __lcd_x=R10
	.DEF __lcd_y=R9
	.DEF __lcd_maxx=R12

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_0x3:
	.DB  0x1,0x0,0x2,0x0,0x4,0x0,0x8,0x0
	.DB  0x10,0x0,0x20,0x0,0x40,0x0,0x80
_0x4:
	.DB  0x1,0x0,0x2,0x0,0x3,0x0,0x4,0x0
	.DB  0x5,0x0,0x6,0x0,0x7,0x0,0x8
_0x5:
	.DB  0x8,0x0,0x7,0x0,0x6,0x0,0x5,0x0
	.DB  0x4,0x0,0x3,0x0,0x2,0x0,0x1
_0x6:
	.DB  0x2,0x0,0x5,0x0,0x0,0x0,0x6,0x0
	.DB  0x7,0x0,0x1,0x0,0x3,0x0,0x4
_0x41:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0
_0x0:
	.DB  0x54,0x65,0x73,0x74,0x65,0x72,0x20,0x45
	.DB  0x74,0x68,0x65,0x72,0x6E,0x65,0x74,0x0
	.DB  0x53,0x74,0x72,0x61,0x69,0x67,0x68,0x74
	.DB  0x0,0x31,0x2C,0x32,0x2C,0x33,0x2C,0x34
	.DB  0x2C,0x35,0x2C,0x36,0x2C,0x37,0x2C,0x38
	.DB  0x0,0x52,0x6F,0x6C,0x6C,0x6F,0x76,0x65
	.DB  0x72,0x0,0x38,0x2C,0x37,0x2C,0x36,0x2C
	.DB  0x35,0x2C,0x34,0x2C,0x33,0x2C,0x32,0x2C
	.DB  0x31,0x0,0x43,0x72,0x6F,0x73,0x73,0x6F
	.DB  0x76,0x65,0x72,0x0,0x33,0x2C,0x36,0x2C
	.DB  0x31,0x2C,0x37,0x2C,0x38,0x2C,0x32,0x2C
	.DB  0x34,0x2C,0x35,0x0,0x44,0x65,0x66,0x65
	.DB  0x63,0x74,0x20,0x20,0x20,0x0,0x2E,0x0
_0x2000003:
	.DB  0x80,0xC0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x0F
	.DW  _afisare_single
	.DW  _0x3*2

	.DW  0x0F
	.DW  _straight
	.DW  _0x4*2

	.DW  0x0F
	.DW  _rollover
	.DW  _0x5*2

	.DW  0x0F
	.DW  _crossover
	.DW  _0x6*2

	.DW  0x10
	.DW  _0x7
	.DW  _0x0*2

	.DW  0x09
	.DW  _0x7+16
	.DW  _0x0*2+16

	.DW  0x10
	.DW  _0x7+25
	.DW  _0x0*2+25

	.DW  0x09
	.DW  _0x7+41
	.DW  _0x0*2+41

	.DW  0x10
	.DW  _0x7+50
	.DW  _0x0*2+50

	.DW  0x0A
	.DW  _0x7+66
	.DW  _0x0*2+66

	.DW  0x10
	.DW  _0x7+76
	.DW  _0x0*2+76

	.DW  0x0A
	.DW  _0x7+92
	.DW  _0x0*2+92

	.DW  0x10
	.DW  _0x7+102
	.DW  _0x0*2

	.DW  0x02
	.DW  _0x7+118
	.DW  _0x0*2+102

	.DW  0x06
	.DW  0x03
	.DW  _0x41*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
;
;Chip type               : ATmega164A
;Program type            : Application
;AVR Core Clock frequency: 20.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega164a.h> // pini si registri
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
;#include <alcd.h>    //LCD
;#include <delay.h>   //delay-uri de timp
;#include <stdlib.h>   //pentru functia itoa()
;
;#define  LED_POWER PORTD.6   //led ROSU
;#define  IN1 PINB.0       //cele 8 intrari
;#define  IN2 PINB.1
;#define  IN3 PINB.2
;#define  IN4 PINB.3
;#define  IN5 PINB.4
;#define  IN6 PINB.5
;#define  IN7 PINB.6
;#define  IN8 PINB.7
;
;#define  BUTON PIND.5     //buton start masuratoare
;
;int afisare_single[8]={1,2,4,8,16,32,64,128};   //vector secventa afisare single LED

	.DSEG
;
;int receptie[10]={0,0,0,0,0,0,0,0};        //vector memorare secventa receptionata
;
;int straight[8]={1,2,3,4,5,6,7,8};      //vector pentru cabluri corecte
;int rollover[8]={8,7,6,5,4,3,2,1};        //vector pentru cabluri corecte
;int crossover[8]={2,5,0,6,7,1,3,4};       //vector pentru cabluri corecte
;
;int i=0;       //variabila pentru for-uri
;int flag_stare=0;  //flag de stare TEST, 0=test_OFF, 1=test_ON
;int sum=0;         //contor pentru verificarea secventelor corecte
;unsigned char buffer[4];   //stochez mesaj pt afisare
;
;void main(void) //ruleaza o singura data pentru configurari de registri
; 0000 002D {

	.CSEG
_main:
; 0000 002E 
; 0000 002F // Crystal Oscillator division factor: 1
; 0000 0030 #pragma optsize-
; 0000 0031 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0032 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0033 #ifdef _OPTIMIZE_SIZE_
; 0000 0034 #pragma optsize+
; 0000 0035 #endif
; 0000 0036 
; 0000 0037 // Input/Output Ports initialization
; 0000 0038 // Port A initialization
; 0000 0039 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 003A // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 003B PORTA=0x00;    //registru de stare logica 0/1
	OUT  0x2,R30
; 0000 003C DDRA=0xFF; //toti iesire    //registru de directie 1=OUT, 0=IN
	LDI  R30,LOW(255)
	OUT  0x1,R30
; 0000 003D 
; 0000 003E // Port B initialization
; 0000 003F // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0040 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0041 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x5,R30
; 0000 0042 DDRB=0x00;   //tot portul intrare pentru receptie
	OUT  0x4,R30
; 0000 0043 
; 0000 0044 // Port C initialization
; 0000 0045 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0046 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0047 PORTC=0x00;
	OUT  0x8,R30
; 0000 0048 DDRC=0xFF;   //tot iesire pt LCD  (nu era obligatoriu)
	LDI  R30,LOW(255)
	OUT  0x7,R30
; 0000 0049 
; 0000 004A // Port D initialization
; 0000 004B // Func7=In Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 004C // State7=T State6=0 State5=P State4=T State3=T State2=T State1=T State0=T
; 0000 004D PORTD=0x20;   //PD5 pull-up (1 logic)
	LDI  R30,LOW(32)
	OUT  0xB,R30
; 0000 004E DDRD=0x40;  //PD6 declarat ca iesire
	LDI  R30,LOW(64)
	OUT  0xA,R30
; 0000 004F 
; 0000 0050 
; 0000 0051 // Timer/Counter 0 initialization
; 0000 0052 // Clock source: System Clock
; 0000 0053 // Clock value: Timer 0 Stopped
; 0000 0054 // Mode: Normal top=0xFF
; 0000 0055 // OC0A output: Disconnected
; 0000 0056 // OC0B output: Disconnected
; 0000 0057 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0058 TCCR0B=0x00;
	OUT  0x25,R30
; 0000 0059 TCNT0=0x00;
	OUT  0x26,R30
; 0000 005A OCR0A=0x00;
	OUT  0x27,R30
; 0000 005B OCR0B=0x00;
	OUT  0x28,R30
; 0000 005C 
; 0000 005D // Timer/Counter 1 initialization
; 0000 005E // Clock source: System Clock
; 0000 005F // Clock value: Timer1 Stopped
; 0000 0060 // Mode: Normal top=0xFFFF
; 0000 0061 // OC1A output: Discon.
; 0000 0062 // OC1B output: Discon.
; 0000 0063 // Noise Canceler: Off
; 0000 0064 // Input Capture on Falling Edge
; 0000 0065 // Timer1 Overflow Interrupt: Off
; 0000 0066 // Input Capture Interrupt: Off
; 0000 0067 // Compare A Match Interrupt: Off
; 0000 0068 // Compare B Match Interrupt: Off
; 0000 0069 TCCR1A=0x00;
	STS  128,R30
; 0000 006A TCCR1B=0x00;
	STS  129,R30
; 0000 006B TCNT1H=0x00;
	STS  133,R30
; 0000 006C TCNT1L=0x00;
	STS  132,R30
; 0000 006D ICR1H=0x00;
	STS  135,R30
; 0000 006E ICR1L=0x00;
	STS  134,R30
; 0000 006F OCR1AH=0x00;
	STS  137,R30
; 0000 0070 OCR1AL=0x00;
	STS  136,R30
; 0000 0071 OCR1BH=0x00;
	STS  139,R30
; 0000 0072 OCR1BL=0x00;
	STS  138,R30
; 0000 0073 
; 0000 0074 // Timer/Counter 2 initialization
; 0000 0075 // Clock source: System Clock
; 0000 0076 // Clock value: Timer2 Stopped
; 0000 0077 // Mode: Normal top=0xFF
; 0000 0078 // OC2A output: Disconnected
; 0000 0079 // OC2B output: Disconnected
; 0000 007A ASSR=0x00;
	STS  182,R30
; 0000 007B TCCR2A=0x00;
	STS  176,R30
; 0000 007C TCCR2B=0x00;
	STS  177,R30
; 0000 007D TCNT2=0x00;
	STS  178,R30
; 0000 007E OCR2A=0x00;
	STS  179,R30
; 0000 007F OCR2B=0x00;
	STS  180,R30
; 0000 0080 
; 0000 0081 // External Interrupt(s) initialization
; 0000 0082 // INT0: Off
; 0000 0083 // INT1: Off
; 0000 0084 // INT2: Off
; 0000 0085 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0086 // Interrupt on any change on pins PCINT8-15: Off
; 0000 0087 // Interrupt on any change on pins PCINT16-23: Off
; 0000 0088 // Interrupt on any change on pins PCINT24-31: Off
; 0000 0089 EICRA=0x00;
	STS  105,R30
; 0000 008A EIMSK=0x00;
	OUT  0x1D,R30
; 0000 008B PCICR=0x00;
	STS  104,R30
; 0000 008C 
; 0000 008D // Timer/Counter 0 Interrupt(s) initialization
; 0000 008E TIMSK0=0x00;
	STS  110,R30
; 0000 008F 
; 0000 0090 // Timer/Counter 1 Interrupt(s) initialization
; 0000 0091 TIMSK1=0x00;
	STS  111,R30
; 0000 0092 
; 0000 0093 // Timer/Counter 2 Interrupt(s) initialization
; 0000 0094 TIMSK2=0x00;
	STS  112,R30
; 0000 0095 
; 0000 0096 // USART0 initialization
; 0000 0097 // USART0 disabled
; 0000 0098 UCSR0B=0x00;
	STS  193,R30
; 0000 0099 
; 0000 009A // USART1 initialization
; 0000 009B // USART1 disabled
; 0000 009C UCSR1B=0x00;
	STS  201,R30
; 0000 009D 
; 0000 009E // Analog Comparator initialization
; 0000 009F // Analog Comparator: Off
; 0000 00A0 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00A1 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 00A2 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 00A3 DIDR1=0x00;
	STS  127,R30
; 0000 00A4 
; 0000 00A5 // ADC initialization
; 0000 00A6 // ADC disabled
; 0000 00A7 ADCSRA=0x00;
	STS  122,R30
; 0000 00A8 
; 0000 00A9 // SPI initialization
; 0000 00AA // SPI disabled
; 0000 00AB SPCR=0x00;
	OUT  0x2C,R30
; 0000 00AC 
; 0000 00AD // TWI initialization
; 0000 00AE // TWI disabled
; 0000 00AF TWCR=0x00;
	STS  188,R30
; 0000 00B0 
; 0000 00B1 // Alphanumeric LCD initialization
; 0000 00B2 // RS - PORTC Bit 0
; 0000 00B3 // RD - PORTC Bit 1
; 0000 00B4 // EN - PORTC Bit 2
; 0000 00B5 // D4 - PORTC Bit 4
; 0000 00B6 // D5 - PORTC Bit 5
; 0000 00B7 // D6 - PORTC Bit 6
; 0000 00B8 // D7 - PORTC Bit 7
; 0000 00B9 // Characters/line: 16
; 0000 00BA lcd_init(16);     //init Lcd cu 16 caractere
	LDI  R26,LOW(16)
	RCALL _lcd_init
; 0000 00BB 
; 0000 00BC 
; 0000 00BD lcd_gotoxy(0,0);
	CALL SUBOPT_0x0
; 0000 00BE lcd_puts("Tester Ethernet");
	__POINTW2MN _0x7,0
	RCALL _lcd_puts
; 0000 00BF 
; 0000 00C0 while (1)
_0x8:
; 0000 00C1       {    //ruleaza la infinit
; 0000 00C2       LED_POWER=1;      //aprind LED
	SBI  0xB,6
; 0000 00C3 
; 0000 00C4       if(flag_stare==1){                  //incepe testul doar daca flag==1 prin apasarea butonului
	CALL SUBOPT_0x1
	BREQ PC+3
	JMP _0xD
; 0000 00C5       LED_POWER=0;
	CBI  0xB,6
; 0000 00C6 
; 0000 00C7               for(i=0;i<=7;i++){   //parcurge pe rand fiecare bit al portului si il aprinde
	CLR  R3
	CLR  R4
_0x11:
	CALL SUBOPT_0x2
	BRGE PC+3
	JMP _0x12
; 0000 00C8                         PORTA=afisare_single[i];
	__GETW1R 3,4
	LDI  R26,LOW(_afisare_single)
	LDI  R27,HIGH(_afisare_single)
	CALL SUBOPT_0x3
	LD   R30,X
	OUT  0x2,R30
; 0000 00C9                          delay_ms(30);         //sta putin pentru a elimina posibile erori de contact
	CALL SUBOPT_0x4
; 0000 00CA 
; 0000 00CB          if( PINB>0) {  //daca detecteaza ceva pe intrare la portul B
	IN   R30,0x3
	CPI  R30,LOW(0x1)
	BRLO _0x13
; 0000 00CC               if(IN1==1)receptie[i]=1;   //scrie valoarea corespunzatoare pinului detectat
	SBIS 0x3,0
	RJMP _0x14
	CALL SUBOPT_0x5
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x40
; 0000 00CD               else if(IN2==1)receptie[i]=2;
_0x14:
	SBIS 0x3,1
	RJMP _0x16
	CALL SUBOPT_0x5
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x40
; 0000 00CE               else if(IN3==1)receptie[i]=3;
_0x16:
	SBIS 0x3,2
	RJMP _0x18
	CALL SUBOPT_0x5
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x40
; 0000 00CF               else if(IN4==1)receptie[i]=4;
_0x18:
	SBIS 0x3,3
	RJMP _0x1A
	CALL SUBOPT_0x5
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x40
; 0000 00D0               else if(IN5==1)receptie[i]=5;
_0x1A:
	SBIS 0x3,4
	RJMP _0x1C
	CALL SUBOPT_0x5
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0x40
; 0000 00D1               else if(IN6==1)receptie[i]=6;
_0x1C:
	SBIS 0x3,5
	RJMP _0x1E
	CALL SUBOPT_0x5
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x40
; 0000 00D2               else if(IN7==1)receptie[i]=7;
_0x1E:
	SBIS 0x3,6
	RJMP _0x20
	CALL SUBOPT_0x5
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x40
; 0000 00D3               else if(IN8==1)receptie[i]=8;
_0x20:
	SBIS 0x3,7
	RJMP _0x22
	CALL SUBOPT_0x5
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
_0x40:
	ST   X+,R30
	ST   X,R31
; 0000 00D4               }  //end if detectie             receptie{7,6,5,4,3,0,0,0}    {7.6.5.4.3.2.1.0}
_0x22:
; 0000 00D5 
; 0000 00D6               PORTA=0;   //stinge tot portul A
_0x13:
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 00D7     }  //end for afisare single
	CALL SUBOPT_0x6
	RJMP _0x11
_0x12:
; 0000 00D8 
; 0000 00D9 
; 0000 00DA     for(i=0;i<=7;i++){      //verificare STRAIGHT
	CLR  R3
	CLR  R4
_0x24:
	CALL SUBOPT_0x2
	BRLT _0x25
; 0000 00DB                          if(receptie[i]==straight[i])sum++;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	LDI  R26,LOW(_straight)
	LDI  R27,HIGH(_straight)
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	BRNE _0x26
	CALL SUBOPT_0x9
; 0000 00DC                           if(sum==8) {   //daca toate 8 firele sunt conectate
_0x26:
	CALL SUBOPT_0xA
	BRNE _0x27
; 0000 00DD                            lcd_clear();
	CALL SUBOPT_0xB
; 0000 00DE                           lcd_gotoxy(0,0);
; 0000 00DF                           lcd_puts("Straight");
	__POINTW2MN _0x7,16
	CALL SUBOPT_0xC
; 0000 00E0                           lcd_gotoxy(0,1);
; 0000 00E1                           lcd_puts("1,2,3,4,5,6,7,8");
	__POINTW2MN _0x7,25
	CALL SUBOPT_0xD
; 0000 00E2                           flag_stare=0;      // opreste rutina de testare daca a gasit cablu valid
; 0000 00E3                           }
; 0000 00E4 
; 0000 00E5 
; 0000 00E6                           }
_0x27:
	CALL SUBOPT_0x6
	RJMP _0x24
_0x25:
; 0000 00E7                           sum=0;
	CLR  R7
	CLR  R8
; 0000 00E8 
; 0000 00E9       if(flag_stare==1)   //daca verificarea anterioara nu a gasit cablu compatibil
	CALL SUBOPT_0x1
	BRNE _0x28
; 0000 00EA       for(i=0;i<=7;i++){     //verificare ROLLOVER
	CLR  R3
	CLR  R4
_0x2A:
	CALL SUBOPT_0x2
	BRLT _0x2B
; 0000 00EB                      if(receptie[i]==rollover[i])sum++;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	LDI  R26,LOW(_rollover)
	LDI  R27,HIGH(_rollover)
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	BRNE _0x2C
	CALL SUBOPT_0x9
; 0000 00EC                      if(sum==8){
_0x2C:
	CALL SUBOPT_0xA
	BRNE _0x2D
; 0000 00ED                      lcd_clear();
	CALL SUBOPT_0xB
; 0000 00EE                           lcd_gotoxy(0,0);
; 0000 00EF                           lcd_puts("Rollover");
	__POINTW2MN _0x7,41
	CALL SUBOPT_0xC
; 0000 00F0                           lcd_gotoxy(0,1);
; 0000 00F1                           lcd_puts("8,7,6,5,4,3,2,1");
	__POINTW2MN _0x7,50
	CALL SUBOPT_0xD
; 0000 00F2                            flag_stare=0;      // opreste rutina de testare daca a gasit cablu valid
; 0000 00F3                           }
; 0000 00F4 
; 0000 00F5                       }
_0x2D:
	CALL SUBOPT_0x6
	RJMP _0x2A
_0x2B:
; 0000 00F6                      sum=0;
_0x28:
	CLR  R7
	CLR  R8
; 0000 00F7 
; 0000 00F8       if(flag_stare==1)
	CALL SUBOPT_0x1
	BREQ PC+3
	JMP _0x2E
; 0000 00F9         for(i=0;i<=7;i++){   //verificare CROSSOVER
	CLR  R3
	CLR  R4
_0x30:
	CALL SUBOPT_0x2
	BRLT _0x31
; 0000 00FA                           if(receptie[i]==crossover[i])sum++;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	LDI  R26,LOW(_crossover)
	LDI  R27,HIGH(_crossover)
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	BRNE _0x32
	CALL SUBOPT_0x9
; 0000 00FB                           if(sum==8){
_0x32:
	CALL SUBOPT_0xA
	BRNE _0x33
; 0000 00FC                            lcd_clear();
	CALL SUBOPT_0xB
; 0000 00FD                           lcd_gotoxy(0,0);
; 0000 00FE                           lcd_puts("Crossover");
	__POINTW2MN _0x7,66
	CALL SUBOPT_0xC
; 0000 00FF                           lcd_gotoxy(0,1);
; 0000 0100                           lcd_puts("3,6,1,7,8,2,4,5");
	__POINTW2MN _0x7,76
	CALL SUBOPT_0xD
; 0000 0101                            flag_stare=0;      // opreste rutina de testare daca a gasit cablu valid
; 0000 0102                           }
; 0000 0103                              else{      //daca sum<8
	RJMP _0x34
_0x33:
; 0000 0104                            lcd_clear();
	CALL SUBOPT_0xB
; 0000 0105                           lcd_gotoxy(0,0);
; 0000 0106                           lcd_puts("Defect   ");
	__POINTW2MN _0x7,92
	RCALL _lcd_puts
; 0000 0107                                           for(i=0;i<=7;i++){     //printeaza vector receptie
	CLR  R3
	CLR  R4
_0x36:
	CALL SUBOPT_0x2
	BRLT _0x37
; 0000 0108                                           lcd_gotoxy(i,1);
	ST   -Y,R3
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
; 0000 0109                                           itoa(receptie[i],buffer);
	CALL SUBOPT_0x5
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_buffer)
	LDI  R27,HIGH(_buffer)
	CALL _itoa
; 0000 010A                                           lcd_puts(buffer);
	LDI  R26,LOW(_buffer)
	LDI  R27,HIGH(_buffer)
	RCALL _lcd_puts
; 0000 010B                                             }
	CALL SUBOPT_0x6
	RJMP _0x36
_0x37:
; 0000 010C                           }
_0x34:
; 0000 010D                            }
	CALL SUBOPT_0x6
	RJMP _0x30
_0x31:
; 0000 010E         flag_stare=0;               //face testul o singura data
_0x2E:
	CLR  R5
	CLR  R6
; 0000 010F     }  //end functie test cablu
; 0000 0110 
; 0000 0111 
; 0000 0112   if(BUTON==0){    //daca e apasat butonul reseteaza test
_0xD:
	SBIC 0x9,5
	RJMP _0x38
; 0000 0113               while(BUTON==0)delay_ms(30);      //asteapta sa dai drumul butonului
_0x39:
	SBIC 0x9,5
	RJMP _0x3B
	CALL SUBOPT_0x4
	RJMP _0x39
_0x3B:
; 0000 0115 lcd_clear();
	CALL SUBOPT_0xB
; 0000 0116   lcd_gotoxy(0,0);
; 0000 0117   lcd_puts("Tester Ethernet");
	__POINTW2MN _0x7,102
	RCALL _lcd_puts
; 0000 0118           flag_stare=1;  //reseteaza flag stare pentru a putea face un nou test
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 5,6
; 0000 0119           sum=0;        //reset contor suma
	CLR  R7
	CLR  R8
; 0000 011A           PORTA=0;   // tine in 0 logic portul de iesire
	LDI  R30,LOW(0)
	OUT  0x2,R30
; 0000 011B 
; 0000 011C                 for(i=0;i<=7;i++){     //reseteaza vector receptie
	CLR  R3
	CLR  R4
_0x3D:
	CALL SUBOPT_0x2
	BRLT _0x3E
; 0000 011D                 receptie[i]=0;   //scrie 0 peste tot in vector
	CALL SUBOPT_0x5
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
; 0000 011E                 lcd_gotoxy(i,1);   //coordonatele de afisare
	ST   -Y,R3
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
; 0000 011F                 lcd_puts(".");
	__POINTW2MN _0x7,118
	RCALL _lcd_puts
; 0000 0120                 delay_ms(50);    //pauza intre afisare de punct = 400ms
	LDI  R26,LOW(50)
	CALL SUBOPT_0xE
; 0000 0121                  }
	CALL SUBOPT_0x6
	RJMP _0x3D
_0x3E:
; 0000 0122 
; 0000 0123   }
; 0000 0124 
; 0000 0125       }
_0x38:
	RJMP _0x8
; 0000 0126 }
_0x3F:
	RJMP _0x3F

	.DSEG
_0x7:
	.BYTE 0x78
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0x8,6
	RJMP _0x2000005
_0x2000004:
	CBI  0x8,6
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x8,5
	RJMP _0x2000007
_0x2000006:
	CBI  0x8,5
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x8,4
	RJMP _0x2000009
_0x2000008:
	CBI  0x8,4
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0x8,3
	RJMP _0x200000B
_0x200000A:
	CBI  0x8,3
_0x200000B:
	__DELAY_USB 13
	SBI  0x8,2
	__DELAY_USB 33
	CBI  0x8,2
	__DELAY_USB 33
	RJMP _0x20A0001
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 250
	RJMP _0x20A0001
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R10,Y+1
	LDD  R9,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0xE
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0xE
	LDI  R30,LOW(0)
	MOV  R9,R30
	MOV  R10,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	CP   R10,R12
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R9
	MOV  R26,R9
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20A0001
_0x2000013:
_0x2000010:
	INC  R10
	SBI  0x8,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x8,0
	RJMP _0x20A0001
_lcd_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	ST   -Y,R26
	SBI  0x7,6
	SBI  0x7,5
	SBI  0x7,4
	SBI  0x7,3
	SBI  0x7,2
	SBI  0x7,0
	SBI  0x7,1
	CBI  0x8,2
	CBI  0x8,0
	CBI  0x8,1
	LDD  R12,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R26,LOW(20)
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
	CALL SUBOPT_0xF
	CALL SUBOPT_0xF
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 500
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20A0001:
	ADIW R28,1
	RET

	.CSEG
_itoa:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_afisare_single:
	.BYTE 0x10
_receptie:
	.BYTE 0x14
_straight:
	.BYTE 0x10
_rollover:
	.BYTE 0x10
_crossover:
	.BYTE 0x10
_buffer:
	.BYTE 0x4
__base_y_G100:
	.BYTE 0x4
__seed_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R3
	CPC  R31,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x3:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R26,LOW(30)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x5:
	__GETW1R 3,4
	LDI  R26,LOW(_receptie)
	LDI  R27,HIGH(_receptie)
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 3,4,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LD   R0,X+
	LD   R1,X
	__GETW1R 3,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	CALL __GETW1P
	CP   R30,R0
	CPC  R31,R1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 7,8,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R7
	CPC  R31,R8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	CALL _lcd_clear
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	CALL _lcd_puts
	CLR  R5
	CLR  R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G100
	__DELAY_USW 500
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x1388
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

;END OF CODE MARKER
__END_OF_CODE:
