/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator

Chip type               : ATmega164A
Program type            : Application
AVR Core Clock frequency: 20.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega164a.h> // pini si registri
#include <alcd.h>    //LCD
#include <delay.h>   //delay-uri de timp
#include <stdlib.h>   //pentru functia itoa()

#define  LED_POWER PORTD.6   //led ROSU
#define  IN1 PINB.0       //cele 8 intrari
#define  IN2 PINB.1
#define  IN3 PINB.2
#define  IN4 PINB.3
#define  IN5 PINB.4
#define  IN6 PINB.5
#define  IN7 PINB.6
#define  IN8 PINB.7

#define  BUTON PIND.5     //buton start masuratoare

int afisare_single[8]={1,2,4,8,16,32,64,128};   //vector secventa afisare single LED  - activare cate un bit

int receptie[10]={0,0,0,0,0,0,0,0};        //vector memorare secventa receptionata

int straight[8]={1,2,3,4,5,6,7,8};      //vector pentru cabluri corecte
int rollover[8]={8,7,6,5,4,3,2,1};        //vector pentru cabluri corecte
int crossover[8]={3,6,1,7,8,2,4,5};       //vector pentru cabluri corecte

int i=0;       //variabila pentru for-uri
int flag_stare=0;  //flag de stare TEST, 0=test_OFF, 1=test_ON
int sum=0;         //contor pentru verificarea secventelor corecte
unsigned char buffer[4];   //stochez mesaj pt afisare 

void main(void) //ruleaza o singura data pentru configurari de registri
{

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTA=0x00;    //registru de stare logica 0/1
DDRA=0xFF; //toti iesire pe portul A   //registru de directie 1=OUT, 0=IN   

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;   //tot portul intrare pentru receptie

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0xFF;   //tot iesire pt LCD  (nu era obligatoriu)

// Port D initialization
// Func7=In Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=0 State5=P State4=T State3=T State2=T State1=T State0=T 
PORTD=0x20;   //PD5 pull-up (1 logic) pt buton
DDRD=0x40;  //PD6 declarat ca iesirept LED

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-15: Off
// Interrupt on any change on pins PCINT16-23: Off
// Interrupt on any change on pins PCINT24-31: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;

// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// USART0 initialization
// USART0 disabled
UCSR0B=0x00;

// USART1 initialization
// USART1 disabled
UCSR1B=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR1=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// RS - PORTC Bit 0
// RD - PORTC Bit 1
// EN - PORTC Bit 2
// D4 - PORTC Bit 4
// D5 - PORTC Bit 5
// D6 - PORTC Bit 6
// D7 - PORTC Bit 7
// Characters/line: 16
lcd_init(16);     //init Lcd cu 16 caractere


lcd_gotoxy(0,0);  // primul rand de la LCD
lcd_puts("Tester Ethernet");    

while (1)
      {    //ruleaza la infinit
      LED_POWER=1;      //aprind LED
      
      if(flag_stare==1){                  //incepe testul doar daca flag==1 prin apasarea butonului 
      LED_POWER=0;     //tine led stins pe durata testarii
         
              for(i=0;i<=7;i++){   //parcurge pe rand fiecare bit al portului de iesire si il aprinde
                        PORTA=afisare_single[i];  
                         delay_ms(30);         //sta putin pentru a elimina posibile erori de contact   //240ms total
              
         if( PINB>0) {  //daca detecteaza ceva pe intrare la portul B 
              if(IN1==1)receptie[i]=1;   //scrie valoarea corespunzatoare pinului detectat
              else if(IN2==1)receptie[i]=2;
              else if(IN3==1)receptie[i]=3;
              else if(IN4==1)receptie[i]=4;
              else if(IN5==1)receptie[i]=5;
              else if(IN6==1)receptie[i]=6;
              else if(IN7==1)receptie[i]=7;  
              else if(IN8==1)receptie[i]=8;
              }  //end if detectie             receptie{7,6,5,4,3,0,0,0}    {7.6.5.4.3.2.1.0}
              
              PORTA=0;   //stinge tot portul A
    }  //end for afisare single 
    
    
    for(i=0;i<=7;i++){      //verificare STRAIGHT
                         if(receptie[i]==straight[i])sum++;     //incrementez sum daca e corect firul
                          if(sum==8) {   //daca toate 8 firele sunt conectate   
                           lcd_clear();
                          lcd_gotoxy(0,0); 
                          lcd_puts("Straight");  
                          lcd_gotoxy(0,1); 
                          lcd_puts("1,2,3,4,5,6,7,8");   
                          flag_stare=0;      // opreste rutina de testare daca a gasit cablu valid
                          }
                            

                          }    
                          sum=0;     
                          
      if(flag_stare==1)   //daca verificarea anterioara nu a gasit cablu compatibil  
      for(i=0;i<=7;i++){     //verificare ROLLOVER
                     if(receptie[i]==rollover[i])sum++;
                     if(sum==8){    
                     lcd_clear();
                          lcd_gotoxy(0,0); 
                          lcd_puts("Rollover");  
                          lcd_gotoxy(0,1); 
                          lcd_puts("8,7,6,5,4,3,2,1");
                           flag_stare=0;      // opreste rutina de testare daca a gasit cablu valid
                          }

                      }   
                     sum=0; 
        
      if(flag_stare==1)  
        for(i=0;i<=7;i++){   //verificare CROSSOVER
                          if(receptie[i]==crossover[i])sum++; 
                          if(sum==8){  
                           lcd_clear(); 
                          lcd_gotoxy(0,0); 
                          lcd_puts("Crossover"); 
                          lcd_gotoxy(0,1); 
                          lcd_puts("3,6,1,7,8,2,4,5"); 
                           flag_stare=0;      // opreste rutina de testare daca a gasit cablu valid
                          }
                             else{      //daca sum<8  = cablu defect
                           lcd_clear();   
                          lcd_gotoxy(0,0); 
                          lcd_puts("Defect   ");     
                                          for(i=0;i<=7;i++){     //printeaza vector receptie
                                          lcd_gotoxy(i,1); 
                                          itoa(receptie[i],buffer);   
                                          lcd_puts(buffer);   
                                            } 
                          }
                           } 
        flag_stare=0;               //face testul o singura data
    }  //end functie test cablu
    
    
  if(BUTON==0){    //daca e apasat butonul reseteaza test
              while(BUTON==0)delay_ms(30);      //asteapta sa dai drumul butonului
              
  lcd_clear();     //sterge LCD    
  lcd_gotoxy(0,0); 
  lcd_puts("Tester Ethernet");
          flag_stare=1;  //reseteaza flag stare pentru a putea face un nou test
          sum=0;        //reset contor suma
          PORTA=0;   // tine in 0 logic portul de iesire
           
                for(i=0;i<=7;i++){     //reseteaza vector receptie
                receptie[i]=0;   //scrie 0 peste tot in vector 
                lcd_gotoxy(i,1);   //coordonatele de afisare 
                lcd_puts(".");   
                delay_ms(50);    //pauza intre afisare de punct = 400ms
                 }
        
  } 

      }
}
